*------------------------------------------------------------------------*
*   This file includes all the user provided averaged amplitude squared  *
*   In this case for the process                                         *
*                                                                        *
*    e + E -> Z Z H                                                      *
*                                                                        *
*   Author: Jorge C. Romao                                               *
*   Date: 04.02.2022                                                     *
*   Email: jorge.romao@tecnico.ulisboa.pt                                *
*------------------------------------------------------------------------*
      real*8 function Msq(rs,ma,mb,m1,m2,m3,p1p2,p1q1,p1q2,
     &     p1q3,p2q1,p2q2,p2q3,q1q2,q1q3,q2q3,m12,p1p1,p2p2,q1q1,
     &     q2q2,q3q3,EPSp1p2q1q2)
      implicit none
      real*8 rs,ma,mb,m1,m2,m3,p1p2,p1q1,p1q2,
     &     p1q3,p2q1,p2q2,p2q3,q1q2,q1q3,q2q3,m12,p1p1,p2p2,q1q1,
     &     q2q2,q3q3,EPSp1p2q1q2
      real*8 gV,gA,MH,cst
      real*8 Msq11,Msq22,Msq33,Msq44,Msq12,Msq13,Msq14
      real*8 Msq23,Msq24,Msq34
      real*8 mw,mz,gw,gz,sw2,ee,GF,pi
      real*8 p3CMmax,E3max,kallen


      common/data/mw,mz,gw,gz,sw2,ee,GF,pi
      ga=-1d0/4d0
      gv=-1d0/4d0+sw2
      MH=m3
      

        Msq11=(-2*(ga**4 + 6*ga**2*gv**2 + gv**4)*(-16*p1q1*p2q1
     &  *p2q2**2 + MZ**6*rs**2 -4*MZ**2*p2q2*(-4*p1q1*p2q1 + 4*p1q1
     &  *q1q2 +p2q2*rs**2) +4*MZ**4*(p1q1*p2q1 + p2q2*(-2*p1q2
     &  + rs**2))))/(MZ**4*(MZ**2 - 2*p2q2)**2*(MH**4 + GZ**2*MZ**2 + 4
     &  *MH**2*q1q3 + 4*q1q3**2))

        Msq22=(-2*(ga**4 + 6*ga**2*gv**2 + gv**4)*(-16*p1q1**2*p1q2
     &  *p2q2 + MZ**6*rs**2 -4*MZ**2*p1q1*(-4*p1q2*p2q2 + 4*p2q2*q1q2
     &  +p1q1*rs**2) +MZ**4*(-8*p1q1*p2q1 + 4*p1q2*p2q2 + 4*p1q1
     &  *rs**2)))/(MZ**4*(MZ**2 - 2*p1q1)**2*(MH**4 + GZ**2*MZ**2 + 4
     &  *MH**2*q2q3 + 4*q2q3**2))

        Msq33=(-2*(ga**4 + 6*ga**2*gv**2 + gv**4)*(-16*p1q1*p1q2**2
     &  *p2q1 + MZ**6*rs**2 -4*MZ**2*p1q2*(-4*p1q1*p2q1 + 4*p2q1*q1q2
     &  +p1q2*rs**2) +4*MZ**4*(p1q1*p2q1 + p1q2*(-2*p2q2 + rs**2))))
     &  /(MZ**4*(MZ**2 - 2*p1q2)**2*(MH**4 + GZ**2*MZ**2 + 4*MH**2
     &  *q1q3 + 4*q1q3**2))

        Msq44=(-2*(ga**4 + 6*ga**2*gv**2 + gv**4)*(-16*p1q2*p2q1**2
     &  *p2q2 + MZ**6*rs**2 -4*MZ**2*p2q1*(-4*p1q2*p2q2 + 4*p1q2*q1q2
     &  +p2q1*rs**2) +MZ**4*(-8*p1q1*p2q1 + 4*p1q2*p2q2 + 4*p2q1
     &  *rs**2)))/(MZ**4*(MZ**2 - 2*p2q1)**2*(MH**4 + GZ**2*MZ**2 + 4
     &  *MH**2*q2q3 + 4*q2q3**2))

        Msq12=(64*EPSp1p2q1q2*ga*gv*(ga**2 + gv**2)*GZ*(MZ**2 + 2*p1q1)
     &  *(MZ**2 + 2*p2q2)*(q1q3 - q2q3))/(MZ**3*(MZ**2 - 2*p1q1)
     &  *(MZ**2 - 2*p2q2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q1q3 + 4
     &  *q1q3**2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q2q3 + 4*q2q3**2)) -(4
     &  *(ga**4 + 6*ga**2*gv**2 + gv**4)*(MH**4 + GZ**2*MZ**2 + 4*q1q3
     &  *q2q3 +2*MH**2*(q1q3 + q2q3))*(4*p1q1*p2q2*(2*p1q2*p2q1 + 2
     &  *p1q1*p2q2 -q1q2*rs**2) +MZ**4*(2*p1q2*p2q1 + 18*p1q1*p2q2
     &  - q1q2*rs**2) -2*MZ**2*(p1q1 + p2q2)*(-2*p1q2*p2q1 + 6*p1q1
     &  *p2q2 + q1q2*rs**2)))/(MZ**4*(MZ**2 - 2*p1q1)*(MZ**2 - 2*p2q2)
     &  *(MH**4 + GZ**2*MZ**2 + 4*MH**2*q1q3 + 4*q1q3**2)*(MH**4
     &  + GZ**2*MZ**2 + 4*MH**2*q2q3 + 4*q2q3**2))
        

        Msq13=(4*(ga**4 + 6*ga**2*gv**2 + gv**4)*(-16*p1q1*p1q2*p2q1
     &  *p2q2 + 5*MZ**6*rs**2 +MZ**2*(8*p1q2*p2q1**2 + 8*p1q1**2*p2q2
     &  +8*p1q1*p2q1*rs**2 - 4*p1q2*p2q2*rs**2 -4*p1q1*q1q2*rs**2 - 4
     &  *p2q1*q1q2*rs**2) -2*MZ**4*(2*p1q1*p2q1 + rs**2*(p1q2 + p2q2
     &  - rs**2))))/(MZ**4*(MZ**2 - 2*p1q2)*(MZ**2 - 2*p2q2)*(MH**4
     &  + GZ**2*MZ**2 + 4*MH**2*q1q3 + 4*q1q3**2))


        Msq14=(64*EPSp1p2q1q2*ga*gv*(ga**2 + gv**2)*GZ*(3*MZ**4 - 4
     &  *p2q1*p2q2 - 2*MZ**2*(p2q1 + p2q2))*(q1q3 - q2q3))/(MZ**3
     &  *(MZ**2 - 2*p2q1)*(MZ**2 - 2*p2q2)*(MH**4 + GZ**2*MZ**2 + 4
     &  *MH**2*q1q3 + 4*q1q3**2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q2q3
     &  + 4*q2q3**2)) +(4*(ga**4 + 6*ga**2*gv**2 + gv**4)*(MH**4
     &  + GZ**2*MZ**2 + 4*q1q3*q2q3 +2*MH**2*(q1q3 + q2q3))*(MZ**4*(2
     &  *p1q2*p2q1 + 2*p1q1*p2q2 +(8*p2q1 + 8*p2q2 - 5*q1q2)*rs**2) +4
     &  *p2q1*p2q2*(2*p1q2*p2q1 + 2*p1q1*p2q2 -q1q2*rs**2) +2*MZ**2*(2
     &  *p1q2*p2q1*(p2q1 - 3*p2q2) +2*p1q1*p2q2*(-3*p2q1 + p2q2)
     &  -(p2q1 + p2q2)*q1q2*rs**2)))/(MZ**4*(MZ**2 - 2*p2q1)*(MZ**2 - 2
     &  *p2q2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q1q3 + 4*q1q3**2)*(MH**4
     &  + GZ**2*MZ**2 + 4*MH**2*q2q3 + 4*q2q3**2))

        Msq23=(64*EPSp1p2q1q2*ga*gv*(ga**2 + gv**2)*GZ*(3*MZ**4 - 4
     &  *p1q1*p1q2 - 2*MZ**2*(p1q1 + p1q2))*(q1q3 - q2q3))/(MZ**3
     &  *(MZ**2 - 2*p1q1)*(MZ**2 - 2*p1q2)*(MH**4 + GZ**2*MZ**2 + 4
     &  *MH**2*q1q3 + 4*q1q3**2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q2q3
     &  + 4*q2q3**2)) +(4*(ga**4 + 6*ga**2*gv**2 + gv**4)*(MH**4
     &  + GZ**2*MZ**2 + 4*q1q3*q2q3 +2*MH**2*(q1q3 + q2q3))*(4*p1q1
     &  *p1q2*(2*p1q2*p2q1 + 2*p1q1*p2q2 -q1q2*rs**2) +MZ**4*(2*p1q1
     &  *p2q2 + 8*p1q1*rs**2 - 5*q1q2*rs**2 +2*p1q2*(p2q1 + 4*rs**2))
     &  +2*MZ**2*(2*p1q1**2*p2q2 +p1q2*(2*p1q2*p2q1 - q1q2*rs**2) -p1q1
     &  *(6*p1q2*(p2q1 + p2q2) + q1q2*rs**2))))/(MZ**4*(MZ**2 - 2*p1q1)
     &  *(MZ**2 - 2*p1q2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q1q3 + 4
     &  *q1q3**2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q2q3 + 4*q2q3**2))


        Msq24=(4*(ga**4 + 6*ga**2*gv**2 + gv**4)*(-16*p1q1*p1q2*p2q1
     &  *p2q2 + 5*MZ**6*rs**2 -4*MZ**2*(-2*p1q2**2*p2q1 - 2*p1q1
     &  *p2q2**2 +p1q1*p2q1*rs**2 + p2q2*q1q2*rs**2 +p1q2*(-2*p2q2
     &  + q1q2)*rs**2) -2*MZ**4*(2*p1q2*p2q2 + rs**2*(p1q1 + p2q1
     &  - rs**2))))/(MZ**4*(MZ**2 - 2*p1q1)*(MZ**2 - 2*p2q1)*(MH**4
     &  + GZ**2*MZ**2 + 4*MH**2*q2q3 + 4*q2q3**2))

        Msq34=(64*EPSp1p2q1q2*ga*gv*(ga**2 + gv**2)*GZ*(MZ**2 + 2*p1q2)
     &  *(MZ**2 + 2*p2q1)*(q1q3 - q2q3))/(MZ**3*(MZ**2 - 2*p1q2)
     &  *(MZ**2 - 2*p2q1)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q1q3 + 4
     &  *q1q3**2)*(MH**4 + GZ**2*MZ**2 + 4*MH**2*q2q3 + 4*q2q3**2)) -(4
     &  *(ga**4 + 6*ga**2*gv**2 + gv**4)*(MH**4 + GZ**2*MZ**2 + 4*q1q3
     &  *q2q3 +2*MH**2*(q1q3 + q2q3))*(4*p1q2*p2q1*(2*p1q2*p2q1 + 2
     &  *p1q1*p2q2 -q1q2*rs**2) +MZ**4*(18*p1q2*p2q1 + 2*p1q1*p2q2
     &  - q1q2*rs**2) -2*MZ**2*(p1q2 + p2q1)*(6*p1q2*p2q1 - 2*p1q1
     &  *p2q2 + q1q2*rs**2)))/(MZ**4*(MZ**2 - 2*p1q2)*(MZ**2 - 2*p2q1)
     &  *(MH**4 + GZ**2*MZ**2 + 4*MH**2*q1q3 + 4*q1q3**2)*(MH**4
     &  + GZ**2*MZ**2 + 4*MH**2*q2q3 + 4*q2q3**2))
        
      
        Msq=1d0/4d0*(Msq11+Msq22+Msq33+Msq44+Msq12+Msq13
     &       +Msq14+Msq23+Msq24+Msq34)

        cst=256d0*GF**3/sqrt(2d0)*MZ**8

        Msq=Msq*cst

        return
        end
